#ifndef MBELT_MOTOR_HPP_
#define MBELT_MOTOR_HPP_

#include <Machine/Machine.hpp>
#include <Machine/IElectricMachine.hpp>
#include <Machine/IBeltMachine.hpp>

/**
 * @brief The machine for the belt motor block.
 */
class MBeltMotor :
    public Machine,
    public IElectricMachine,
    public IBeltMachine
{
public:
    MBeltMotor(LocalWorld &world, glm::ivec3 pos);

    virtual void serializeState(std::vector<uint8_t> &outBytes) override;
    virtual void deserializeState(const uint8_t *data, size_t size) override;
    virtual bool canConnectElectricWire(Side side) override;
    virtual void update() override;
    virtual void onItemStackEntering(Side side, ItemStack &stack) override;
};

#endif